Combination Sum IV中两种JAVA动态规划解法的不同

leetcode题目:https://leetcode.com/problems/combination-sum-iv/#/description

Given an integer array with all positive numbers and no duplicates,
find the number of possible combinations that add up to a positive
integer target.

Example:

nums = [1, 2, 3] target = 4

The possible combination ways are: (1, 1, 1, 1) (1, 1, 2) (1, 2, 1)
(1, 3) (2, 1, 1) (2, 2) (3, 1)

Note that different sequences are counted as different combinations.

solution 1 : (correct one)

public class Solution {

    public int combinationSum4(int[] nums, int target) {
        // 在递归过程中,如果状态集是有限的,我们可以采用动态规划的方法,把每个状态的结果记录下来,以减少计算量。
        int[] dp = new int[target + 1];
        dp[0] = 1;
        for (int i = 1; i < dp.length; i++) {        //  outer loop is  to  traversal  dp array 
            for (int j = 0; j < nums.length; j++) {    // inner loop is to  traversal  nums array  
                if (i - nums[j] >= 0) {
                    dp[i] += dp[i - nums[j]];
                }
            }
        }
        return dp[target];
    }

}

solution 2:(wrong one )

public class Solution {

    public int combinationSum4(int[] nums, int target) {
        int [] dp = new int[target + 1];

        dp[0] = 1;
        for (int i = 0; i < nums.length; i++) {        //  outer loop is  to  traversal  nums array and nums array should be ASC ordered
            for (int j = nums[i]; j <= target; j++) {   //  inner loop is to  traversal  dp array  
                dp[j] += dp[j - nums[i]];
            }
        }
        return dp[target];
    }

}

when give a testcase:

nums = [1, 2, 3]
target = 4

solution 1 got the answer 7:
The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)
i wanna say this is Permutations not combination.

solution 2 give the answer 4, Obviously, delete the same combination from the above possible Permutations, eg (1, 1, 2) (1, 2, 1) (2, 1, 1) (1, 3) (3, 1), the answer is 4.

so, solution 1 could get the Permutation Sum, and solution 2 could get the Combination Sum. this is because the count order of dp and nums is different.

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值